// constants extracted from %systemroot%\system32\wbem\wbemdisp.tlb
var wbemPrivilegeSecurity = 7, wbemPrivilegeBackup = 16;

var DEBUG = 0;  // 0 = production, -1 = debug
    
if (DEBUG) debugger;

var hr = main();
WScript.Quit(0);

function main() 
{
	if (DEBUG) debugger;
	try
	{   
	    WScript.Echo("Acquiring EventLogs collection\n");
       
		var oSWbemSvcs = GetObject("winmgmts:{(Security)}");
    
		if (DEBUG)
		{
		    debugger;  // break for debugging
		    var bsBuffer = oSWbemSvcs.Security_.AuthenticationLevel  // 6
		    bsBuffer = oSWbemSvcs.Security_.ImpersonationLevel  // 3
			oSWbemSvcs.Security_.Privileges.Add(wbemPrivilegeSecurity)
		    oSWbemSvcs.Security_.Privileges.Add(wbemPrivilegeBackup)
		    bsBuffer = oSWbemSvcs.Security_.AuthenticationLevel  // 6
		    bsBuffer = oSWbemSvcs.Security_.ImpersonationLevel  // 3
		}
	
		if (DEBUG) debugger;	    
		var oSWbemObjectSet = oSWbemSvcs.InstancesOf("Win32_NTEventlogFile");
		// note - neither of the following work
		// var oSWbemObjectSetEnum = oSWbemObjectSet._NewEnum;
		// var oSWbemObjectSetEnum = new Enumerator(oSWbemObjectSet._NewEnum);
		// note - but either of the following do work
		var oSWbemObjectSetEnum = new Enumerator(oSWbemObjectSet);
		// var oSWbemObjectSetEnum = new Enumerator(oSWbemSvcs.InstancesOf("Win32_NTEventlogFile"));
			
		if (DEBUG)
		{
		    debugger;  // break for debugging
		    var iBuffer = oSWbemObjectSet.Count  // on mydevc = 6
		}
		    
		// select explicit item from SWbemObjectSet
		if (DEBUG)
		{
		    debugger;  // break for debugging
			var oShell = WScript.CreateObject("WScript.Shell");
		    var bsSystemDrive = oShell.ExpandEnvironmentStrings("%systemdrive%");
			var bsSystemRoot = oShell.ExpandEnvironmentStrings("%systemroot%");
			oShell = null;
		    var bsSystemFld = bsSystemRoot.substr(bsSystemDrive.length + 1);
		    var bsEvntLogFile = "AppEvent.evt";  // AppEvent.evt | DnsEvent.evt | File Rep.evt | NtDs.evt | NtFrs.evt | SecEvent.evt | SysEvent.evt
		    // Path_ properties of the form "\\MYDEVC\root\cimv2:Win32_NTEventlogFile.Name="C:\\OS\\system32\\config\\AppEvent.Evt""
		    // but the hostname and namespace path can be left out, note the \\ path separators and value quote wrappers are necessary
		    // format is "\\<Server>\<Namespace>:<Class>.Name="<Path_.Path>"
		    bsBuffer = "Win32_NTEventlogFile.Name=\"" + bsSystemDrive + "\\\\" + bsSystemFld + "\\\\system32\\\\config\\\\" + bsEvntLogFile + "\"";
		    var oSWbemObject = oSWbemObjectSet.Item(bsBuffer, 0);  // get specific item from SWbemObjectSet
		    oSWbemObject.ClearEventLog;
		    bsEvntLogFile = "SysEvent.evt";  // AppEvent.evt | DnsEvent.evt | File Rep.evt | NtDs.evt | NtFrs.evt | SecEvent.evt | SysEvent.evt
			bsBuffer = "Win32_NTEventlogFile.Name=\"" + bsSystemDrive + "\\\\" + bsSystemFld + "\\\\system32\\\\config\\\\" + bsEvntLogFile + "\"";
		    var oSWbemObject = oSWbemObjectSet.Item(bsBuffer, 0);  // get specific item from SWbemObjectSet
		    oSWbemObject.ClearEventLog;
		}
    
    	if (DEBUG) debugger;
    	
		// iterate through entire SWbemObjectSetEnum
		for ( ;!oSWbemObjectSetEnum.atEnd(); oSWbemObjectSetEnum.moveNext())
		{
			var oSWbemObject = oSWbemObjectSetEnum.item();
					
			if (DEBUG)
			{
		        debugger;  // break for debugging
		        var oSWbemProperty = oSWbemObject.Properties_.Item("Caption");  // i.e. ISWbemProperty object
		        var vBuffer = oSWbemProperty.Value;  // i.e. c:\os\system32\config\appevent.evt"
		        vBuffer = oSWbemObject.Properties_.Item("Caption", 0);  // i.e. "c:\os\system32\config\appevent.evt"
		        vBuffer = oSWbemObject.Properties_.Item("Name", 0);  // i.e. "C:\OS\system32\config\AppEvent.Evt"
		        vBuffer = oSWbemObject.Properties_.Item("FileName", 0);  // i.e. "appevent"
		        vBuffer = oSWbemObject.Properties_.Item("LogfileName", 0);  // i.e. "Application"
		        vBuffer = oSWbemObject.Path_;  // i.e. "\\MYDEVC\root\cimv2:Win32_NTEventlogFile.Name="C:\\OS\\system32\\config\\AppEvent.Evt""
		        vBuffer = oSWbemObject.Path_.Server;  //  i.e. "MYDEVC"
		        vBuffer = oSWbemObject.Path_.Namespace;  // i.e. "root\cimv2"
		        vBuffer = oSWbemObject.Path_.Class;  // i.e. "Win32_NTEventlogFile
		        vBuffer = oSWbemObject.Path_.Path;  // i.e. "\\MYDEVC\root\cimv2:Win32_NTEventlogFile.Name="C:\\OS\\system32\\config\\AppEvent.Evt""
		    }
			WScript.Echo("\tclearing " + oSWbemObject.Properties_.Item("LogfileName", 0) + " EventLog");
		    oSWbemObject.ClearEventLog();
		}
		
		if (DEBUG) debugger;
		
   		throw null;
	}

	catch(oError) 
	{
		if (DEBUG) debugger;
		
		WScript.Echo("\nReleasing EventLogs collection\n")
		
		// set initialized objects to null
		oSWbemSvcs = null;
		oSWbemObjectSet = null;
		oSWbemObjectSetEnum = null;
		oSWbemObject = null
		oSWbemProperty = null;
		
		if (null != oError) 
		{
	  		WScript.Echo(oError.number + "\n" + oError.description);
	  		return 1;
		}
		else
	  		return 0;
	}
}
