Attribute VB_Name = "modMain"
Option Explicit  '// forces all variables used to be declared first

'// note - after making changes and rebuilding you must run
'// "<vstudio>\vc98\bin\editbin.exe" /SUBSYSTEM:CONSOLE clrlogs.exe
'// in order to enable console output api calls.  For editbin.exe
'// to operate correctly it requires that you first run the
'// "<vstudio>\vc98\bin\vcvars32.bat" routine in order to get the
'// necessary supporting files into your cmd.exe environment path

Public Declare Function GetStdHandle Lib "kernel32" (ByVal nStdHandle As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function WriteConsole Lib "kernel32" Alias "WriteConsoleA" (ByVal hConsoleOutput As Long, lpBuffer As Any, ByVal nNumberOfCharsToWrite As Long, lpNumberOfCharsWritten As Long, lpReserved As Any) As Long
Public Const STD_OUTPUT_HANDLE = -11&
Public Const CUSTOM_ERROR_OFFSET = 512
Public Const UDEBUG = 0  '// 0 = production, -1 = debug

Private Sub Main()
    On Error GoTo catch  '// declare all purpose error handler
    
    If (UDEBUG) Then
        Stop  '// break for debugging
    End If
    
    '// Dim oWbemSvcs As Object, oSWbemObjectSet As Object, oSWbemObject As Object, oSWbemProperty As Object
    '// add project/references/Microsoft WMI V1.1 Scripting Library (%systemroot%\system32\wbem\wbemdisp.tlb [/.dll])
    Dim oSWbemSvcs As ISWbemServices, oSWbemObjectSet As ISWbemObjectSet, oSWbemObject As ISWbemObject, oSWbemProperty As ISWbemProperty, _
        vBuffer As Variant, sBuffer As String, iBuffer As Integer, _
        hConsole As Long, lBuffer As Long
    
    hConsole = GetStdHandle(STD_OUTPUT_HANDLE)
    If (0 = hConsole) Then
        Call Err.Raise(vbObjectError + CUSTOM_ERROR_OFFSET, App.EXEName & "modMain.Main()", "GetStdHandle failed to return a handle")
    End If
    sBuffer = vbCrLf & "Acquiring EventLogs collection" & vbCrLf & vbCrLf
    If (Not UDEBUG) Then
        Call WriteConsole(hConsole, ByVal sBuffer, Len(sBuffer), lBuffer, ByVal 0&)
    Else
        Debug.Print (sBuffer)
    End If
   
    Set oSWbemSvcs = GetObject("winmgmts:{(Security)}")
    
    If (UDEBUG) Then
        Stop  '// break for debugging
        sBuffer = oSWbemSvcs.Security_.AuthenticationLevel  '// 6
        sBuffer = oSWbemSvcs.Security_.ImpersonationLevel  '// 3
        Call oSWbemSvcs.Security_.Privileges.Add(wbemPrivilegeSecurity)
        Call oSWbemSvcs.Security_.Privileges.Add(wbemPrivilegeBackup)
        sBuffer = oSWbemSvcs.Security_.AuthenticationLevel  '// 6
        sBuffer = oSWbemSvcs.Security_.ImpersonationLevel  '// 3
    End If
        
    Set oSWbemObjectSet = oSWbemSvcs.InstancesOf("Win32_NTEventlogFile")
    If (UDEBUG) Then
        Stop  '// break for debugging
        iBuffer = oSWbemObjectSet.Count  '// on mydevc = 6
    End If
        
    '// select explicit item from SWbemObjectectSet
    If (UDEBUG) Then
        Stop  '// break for debugging
        Dim sSystemDrive As String, sSystemRoot As String, sSystemFld As String, sEvntLogFile As String
        sSystemDrive = Environ("SYSTEMDRIVE")
        sSystemRoot = Environ("SYSTEMROOT")
        sSystemFld = Mid(sSystemRoot, Len(sSystemDrive) + 2)
        sEvntLogFile = "AppEvent.evt"  '// AppEvent.evt | DnsEvent.evt | File Rep.evt | NtDs.evt | NtFrs.evt | SecEvent.evt | SysEvent.evt
        '// Path_ properties of the form "\\MYDEVC\root\cimv2:Win32_NTEventlogFile.Name="C:\\OS\\system32\\config\\AppEvent.Evt""
        '// but the hostname and namespace path can be left out, note the \\ path separators and value quote wrappers are necessary
        '// format is "\\<Server>\<Namespace>:<Class>.Name="<Path_.Path>"
        sBuffer = "Win32_NTEventlogFile.Name=" & Chr(34) & sSystemDrive & "\\" & sSystemFld & "\\system32\\config\\" & sEvntLogFile & Chr(34)
        Set oSWbemObject = oSWbemObjectSet.Item(sBuffer, 0)  '// get specific item from SWbemObjectSet
        oSWbemObject.ClearEventLog
        sEvntLogFile = "SysEvent.evt"  '// AppEvent.evt | DnsEvent.evt | File Rep.evt | NtDs.evt | NtFrs.evt | SecEvent.evt | SysEvent.evt
        sBuffer = "Win32_NTEventlogFile.Name=" & Chr(34) & sSystemDrive & "\\" & sSystemFld & "\\system32\\config\\" & sEvntLogFile & Chr(34)
        Set oSWbemObject = oSWbemObjectSet.Item(sBuffer, 0)  '// get specific item from SWbemObjectSet
        oSWbemObject.ClearEventLog
    End If
    
    '// iterate through entire SWbemObjectSet
    For Each oSWbemObject In oSWbemObjectSet
        If (UDEBUG) Then
            Stop  '// break for debugging
            Set oSWbemProperty = oSWbemObject.Properties_.Item("Caption")  '// i.e. ISWbemProperty object
            vBuffer = oSWbemProperty.Value  '// i.e. c:\os\system32\config\appevent.evt"
            vBuffer = oSWbemObject.Properties_.Item("Caption", 0)  '// i.e. "c:\os\system32\config\appevent.evt"
            vBuffer = oSWbemObject.Properties_.Item("Name", 0)  '// i.e. "C:\OS\system32\config\AppEvent.Evt"
            vBuffer = oSWbemObject.Properties_.Item("FileName", 0)  '// i.e. "appevent"
            vBuffer = oSWbemObject.Properties_.Item("LogfileName", 0)  '// i.e. "Application"
            vBuffer = oSWbemObject.Path_  '// i.e. "\\MYDEVC\root\cimv2:Win32_NTEventlogFile.Name="C:\\OS\\system32\\config\\AppEvent.Evt""
            vBuffer = oSWbemObject.Path_.Server  '//  i.e. "MYDEVC"
            vBuffer = oSWbemObject.Path_.Namespace  '// i.e. "root\cimv2"
            vBuffer = oSWbemObject.Path_.Class  '// i.e. "Win32_NTEventlogFile
            vBuffer = oSWbemObject.Path_.Path  '// i.e. "\\MYDEVC\root\cimv2:Win32_NTEventlogFile.Name="C:\\OS\\system32\\config\\AppEvent.Evt""
        End If
        sBuffer = vbTab & "clearing " & oSWbemObject.Properties_.Item("LogfileName", 0) & " EventLog" & vbCrLf
        If (Not UDEBUG) Then
            Call WriteConsole(hConsole, ByVal sBuffer, Len(sBuffer), lBuffer, ByVal 0&)
        Else
            Debug.Print (sBuffer)
        End If
        oSWbemObject.ClearEventLog
    Next
    
    If (UDEBUG) Then
        Stop  '// break for debugging
    End If
    
    Call Err.Raise(vbObjectError + CUSTOM_ERROR_OFFSET, App.EXEName & "modMain.Main()", "The operation completed successfully.")

catch:
    If (UDEBUG) Then
        Stop  '// break for debugging
    End If
    sBuffer = vbCrLf & "Releasing EventLogs collection" & vbCrLf
    If (Not UDEBUG And 0 <> hConsole) Then
        Call WriteConsole(hConsole, ByVal sBuffer, Len(sBuffer), lBuffer, ByVal 0&)
    Else
        Debug.Print (sBuffer)
    End If
    Call CloseHandle(hConsole)
    Set oSWbemProperty = Nothing
    Set oSWbemObject = Nothing
    Set oSWbemObjectSet = Nothing
    Set oSWbemSvcs = Nothing
End Sub
