Option Explicit  '// forces all variables used to be declared first

'// constants extracted from %systemroot%\system32\wbem\wbemdisp.tlb
Const wbemPrivilegeSecurity = 7, wbemPrivilegeBackup = 16
Const CUSTOM_ERROR_OFFSET = 512
Const UDEBUG = 0  '// 0 = production, -1 = debug
    
If (UDEBUG) Then
	Stop
End If

'// launch script using "cscript //NoLogo clrlogs.vbs"
Call Main()
WScript.Quit(0)

Sub Main()
    '// On Error GoTo catch
           
    WScript.Echo("Acquiring EventLogs collection" & vbCrLf)
       
    Dim oSWbemSvcs, oSWbemObjectSet, oShell, oSWbemObject, oSWbemProperty, _
		sBuffer, iBuffer, sSystemDrive, sSystemRoot, sSystemFld, sEvntLogFile, vBuffer

    Set oSWbemSvcs = GetObject("winmgmts:{(Security)}")
    
    If (UDEBUG) Then
        Stop  '// break for debugging
        sBuffer = oSWbemSvcs.Security_.AuthenticationLevel  '// 6
        sBuffer = oSWbemSvcs.Security_.ImpersonationLevel  '// 3
        Call oSWbemSvcs.Security_.Privileges.Add(wbemPrivilegeSecurity)
        Call oSWbemSvcs.Security_.Privileges.Add(wbemPrivilegeBackup)
        sBuffer = oSWbemSvcs.Security_.AuthenticationLevel  '// 6
        sBuffer = oSWbemSvcs.Security_.ImpersonationLevel  '// 3
    End If
        
    Set oSWbemObjectSet = oSWbemSvcs.InstancesOf("Win32_NTEventlogFile")
    If (UDEBUG) Then
        Stop  '// break for debugging
        iBuffer = oSWbemObjectSet.Count  '// on mydevc = 6
    End If
        
    '// select explicit item from SWbemObjectSet
    If (UDEBUG) Then
        Stop  '// break for debugging
        Set oShell = WScript.CreateObject("WScript.Shell")
        sSystemDrive = oShell.ExpandEnvironmentStrings("%systemdrive%")
        sSystemRoot = oShell.ExpandEnvironmentStrings("%systemroot%")
		Set oShell = Nothing
		sSystemFld = Mid(sSystemRoot, Len(sSystemDrive) + 2)
        sEvntLogFile = "AppEvent.evt"  '// AppEvent.evt | DnsEvent.evt | File Rep.evt | NtDs.evt | NtFrs.evt | SecEvent.evt | SysEvent.evt
        '// Path_ properties of the form "\\MYDEVC\root\cimv2:Win32_NTEventlogFile.Name="C:\\OS\\system32\\config\\AppEvent.Evt""
        '// but the hostname and namespace path can be left out, note the \\ path separators and value quote wrappers are necessary
        '// format is "\\<Server>\<Namespace>:<Class>.Name="<Path_.Path>"
        sBuffer = "Win32_NTEventlogFile.Name=" & Chr(34) & sSystemDrive & "\\" & sSystemFld & "\\system32\\config\\" & sEvntLogFile & Chr(34)
        Set oSWbemObject = oSWbemObjectSet.Item(sBuffer, 0)  '// get specific item from SWbemObjectSet
        oSWbemObject.ClearEventLog
        sEvntLogFile = "SysEvent.evt"  '// AppEvent.evt | DnsEvent.evt | File Rep.evt | NtDs.evt | NtFrs.evt | SecEvent.evt | SysEvent.evt
        sBuffer = "Win32_NTEventlogFile.Name=" & Chr(34) & sSystemDrive & "\\" & sSystemFld & "\\system32\\config\\" & sEvntLogFile & Chr(34)
        Set oSWbemObject = oSWbemObjectSet.Item(sBuffer, 0)  '// get specific item from SWbemObjectSet
        oSWbemObject.ClearEventLog
    End If
    
    '// iterate through entire SWbemObjectSet
    For Each oSWbemObject In oSWbemObjectSet
        If (UDEBUG) Then
            Stop  '// break for debugging
            Set oSWbemProperty = oSWbemObject.Properties_.Item("Caption")  '// i.e. ISWbemProperty object
            vBuffer = oSWbemProperty.Value  '// i.e. c:\os\system32\config\appevent.evt"
            vBuffer = oSWbemObject.Properties_.Item("Caption", 0)  '// i.e. "c:\os\system32\config\appevent.evt"
            vBuffer = oSWbemObject.Properties_.Item("Name", 0)  '// i.e. "C:\OS\system32\config\AppEvent.Evt"
            vBuffer = oSWbemObject.Properties_.Item("FileName", 0)  '// i.e. "appevent"
            vBuffer = oSWbemObject.Properties_.Item("LogfileName", 0)  '// i.e. "Application"
            vBuffer = oSWbemObject.Path_  '// i.e. "\\MYDEVC\root\cimv2:Win32_NTEventlogFile.Name="C:\\OS\\system32\\config\\AppEvent.Evt""
            vBuffer = oSWbemObject.Path_.Server  '//  i.e. "MYDEVC"
            vBuffer = oSWbemObject.Path_.Namespace  '// i.e. "root\cimv2"
            vBuffer = oSWbemObject.Path_.Class  '// i.e. "Win32_NTEventlogFile
            vBuffer = oSWbemObject.Path_.Path  '// i.e. "\\MYDEVC\root\cimv2:Win32_NTEventlogFile.Name="C:\\OS\\system32\\config\\AppEvent.Evt""
        End If
		WScript.Echo(vbTab & "clearing " & oSWbemObject.Properties_.Item("LogfileName", 0) & " EventLog")
        oSWbemObject.ClearEventLog
    Next
    
    If (UDEBUG) Then
        Stop  '// break for debugging
    End If
    
    '// Call Err.Raise(vbObjectError + CUSTOM_ERROR_OFFSET, App.EXEName & "modMain.Main", "The operation completed successfully.")

'// catch:
	If (UDEBUG) Then
        Stop  '// break for debugging
    End If
    WScript.Echo(vbCrLf & "Releasing EventLogs collection")
	Set oShell = Nothing
    Set oSWbemProperty = Nothing
    Set oSWbemObject = Nothing
    Set oSWbemObjectSet = Nothing
    Set oSWbemSvcs = Nothing
End Sub
